#pragma compress 1

#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <cstrike>

#define PLUGIN  "CS Revo: C4 Icon Model Top"
#define VERSION "1.0"
#define AUTHOR  "Wilian M."

#define C4_ICON "models/csrevo/c4_model_icon.mdl"

new xEntC4

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)

	register_forward(FM_SetModel, "xSetModel", false)
	register_forward(FM_Think, "xThink", false)
}

public plugin_precache()
{
	precache_model(C4_ICON)
}

public xThink(ent)
{
	if(!pev_valid(ent))
		return FMRES_IGNORED
	
	if(ent != xEntC4)
		return FMRES_IGNORED

	static xC4
	xC4 = pev(ent, pev_iuser1)

	if(!pev_valid(xC4))
	{
		set_pev(ent, pev_flags, FL_KILLME)
		xEntC4 = 0

		return FMRES_SUPERCEDE
	}

	set_pev(ent, pev_nextthink, get_gametime())

	return FMRES_IGNORED
}

public xSetModel(ent, model[])
{
	if(!pev_valid(ent))
		return FMRES_IGNORED

	static xClassName[32]
	pev(ent, pev_classname, xClassName, charsmax(xClassName))

	if(!equal(xClassName, "weaponbox"))
		return FMRES_IGNORED

	if(equal(model, "models/w_backpack.mdl"))
	{
		if((xEntC4 = xCreateModel(ent)))
			return FMRES_IGNORED
	}

	return FMRES_IGNORED
}

public xCreateModel(ent)
{
	new xEnt = create_entity("info_target")

	if(!pev_valid(xEnt))
		return false
	
	engfunc(EngFunc_SetModel, xEnt, C4_ICON)
	set_pev(xEnt, pev_iuser1, ent)
	set_pev(xEnt, pev_framerate, 1.0)
	set_pev(xEnt, pev_animtime, get_gametime())
	set_pev(xEnt, pev_movetype, MOVETYPE_FOLLOW)
	set_pev(xEnt, pev_aiment, ent)
	set_pev(xEnt, pev_nextthink, get_gametime())

	return xEnt
}